<html>
<head>
<title>OgreLodStrategy.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreLodStrategy.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreLodStrategy_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __Lod_Strategy_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __Lod_Strategy_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreMesh_8h.html">OgreMesh.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreMovableObject_8h.html">OgreMovableObject.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreCamera_8h.html">OgreCamera.h</a>&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre {
<a name="l00039"></a>00039 
<a name="l00053"></a><a class="code" href="classOgre_1_1LodStrategy.html">00053</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1LodStrategy.html" title="Strategy for determining level of detail.">LodStrategy</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">LodAlloc</a>
<a name="l00054"></a>00054     {
<a name="l00055"></a>00055     <span class="keyword">protected</span>:
<a name="l00057"></a><a class="code" href="classOgre_1_1LodStrategy.html#a769ac92afc0408591b50fd33f71372d0">00057</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1LodStrategy.html#a769ac92afc0408591b50fd33f71372d0" title="Name of this strategy.">mName</a>;
<a name="l00058"></a>00058 
<a name="l00060"></a>00060         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getValueImpl(<span class="keyword">const</span> <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a> *movableObject, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a> *camera) <span class="keyword">const</span> = 0;
<a name="l00061"></a>00061 
<a name="l00062"></a>00062     <span class="keyword">public</span>:
<a name="l00064"></a>00064         <a class="code" href="classOgre_1_1LodStrategy.html" title="Strategy for determining level of detail.">LodStrategy</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00065"></a>00065 
<a name="l00067"></a>00067         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1LodStrategy.html" title="Strategy for determining level of detail.">LodStrategy</a>();
<a name="l00068"></a>00068 
<a name="l00070"></a>00070         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getBaseValue() <span class="keyword">const</span> = 0;
<a name="l00071"></a>00071 
<a name="l00073"></a>00073         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> transformBias(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> factor) <span class="keyword">const</span> = 0;
<a name="l00074"></a>00074 
<a name="l00082"></a>00082         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> transformUserValue(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> userValue) <span class="keyword">const</span>;
<a name="l00083"></a>00083 
<a name="l00085"></a>00085         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getValue(<span class="keyword">const</span> <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a> *movableObject, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a> *camera) <span class="keyword">const</span>;
<a name="l00086"></a>00086 
<a name="l00088"></a>00088         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> getIndex(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> value, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Mesh.html#afe83b164df6c330c0bd7b7c5c76d04e3">Mesh::MeshLodUsageList</a>&amp; meshLodUsageList) <span class="keyword">const</span> = 0;
<a name="l00089"></a>00089 
<a name="l00091"></a>00091         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> getIndex(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> value, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Material.html#a4c0945a06c098b9b1d366d9d3ba857fe" title="distance list used to specify LOD">Material::LodValueList</a>&amp; materialLodValueList) <span class="keyword">const</span> = 0;
<a name="l00092"></a>00092 
<a name="l00094"></a>00094         <span class="keyword">virtual</span> <span class="keywordtype">void</span> sort(<a class="code" href="classOgre_1_1Mesh.html#afe83b164df6c330c0bd7b7c5c76d04e3">Mesh::MeshLodUsageList</a>&amp; meshLodUsageList) <span class="keyword">const</span> = 0;
<a name="l00095"></a>00095 
<a name="l00097"></a>00097         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isSorted(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Mesh.html#a7d726e72a87c304798883fbecbe6810a">Mesh::LodValueList</a>&amp; values) <span class="keyword">const</span> = 0;
<a name="l00098"></a>00098 
<a name="l00100"></a>00100         <span class="keywordtype">void</span> assertSorted(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Mesh.html#a7d726e72a87c304798883fbecbe6810a">Mesh::LodValueList</a>&amp; values) <span class="keyword">const</span>;
<a name="l00101"></a>00101 
<a name="l00103"></a><a class="code" href="classOgre_1_1LodStrategy.html#a4dc72d5700c871cb12a1409c7e71e08b">00103</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1LodStrategy.html#a4dc72d5700c871cb12a1409c7e71e08b" title="Get the name of this strategy.">getName</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mName; }
<a name="l00104"></a>00104 
<a name="l00105"></a>00105     <span class="keyword">protected</span>:
<a name="l00107"></a>00107         <span class="keyword">static</span> <span class="keywordtype">bool</span> isSortedAscending(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Mesh.html#a7d726e72a87c304798883fbecbe6810a">Mesh::LodValueList</a>&amp; values);
<a name="l00109"></a>00109         <span class="keyword">static</span> <span class="keywordtype">bool</span> isSortedDescending(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Mesh.html#a7d726e72a87c304798883fbecbe6810a">Mesh::LodValueList</a>&amp; values);
<a name="l00110"></a>00110 
<a name="l00112"></a>00112         <span class="keyword">static</span> <span class="keywordtype">void</span> sortAscending(<a class="code" href="classOgre_1_1Mesh.html#afe83b164df6c330c0bd7b7c5c76d04e3">Mesh::MeshLodUsageList</a>&amp; meshLodUsageList);
<a name="l00114"></a>00114         <span class="keyword">static</span> <span class="keywordtype">void</span> sortDescending(<a class="code" href="classOgre_1_1Mesh.html#afe83b164df6c330c0bd7b7c5c76d04e3">Mesh::MeshLodUsageList</a>&amp; meshLodUsageList);
<a name="l00115"></a>00115 
<a name="l00117"></a>00117         <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> getIndexAscending(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> value, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Mesh.html#afe83b164df6c330c0bd7b7c5c76d04e3">Mesh::MeshLodUsageList</a>&amp; meshLodUsageList);
<a name="l00119"></a>00119         <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> getIndexDescending(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> value, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Mesh.html#afe83b164df6c330c0bd7b7c5c76d04e3">Mesh::MeshLodUsageList</a>&amp; meshLodUsageList);
<a name="l00120"></a>00120 
<a name="l00122"></a>00122         <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> getIndexAscending(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> value, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Material.html#a4c0945a06c098b9b1d366d9d3ba857fe" title="distance list used to specify LOD">Material::LodValueList</a>&amp; materialLodValueList);
<a name="l00124"></a>00124         <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> getIndexDescending(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> value, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Material.html#a4c0945a06c098b9b1d366d9d3ba857fe" title="distance list used to specify LOD">Material::LodValueList</a>&amp; materialLodValueList);
<a name="l00125"></a>00125 
<a name="l00126"></a>00126     };
<a name="l00130"></a>00130 } <span class="comment">// namespace</span>
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
